diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/network/utils/radiotap-header.cc ns-3.44/src/network/utils/radiotap-header.cc
--- ns-3.43/src/network/utils/radiotap-header.cc	2024-10-09 16:41:10.072656600 -0700
+++ ns-3.44/src/network/utils/radiotap-header.cc	2025-03-09 16:55:49.679372300 -0700
@@ -759,138 +724,468 @@
 }
 
 void
-RadiotapHeader::SetMcsFields(uint8_t known, uint8_t flags, uint8_t mcs)
+RadiotapHeader::SetMcsFields(const McsFields& mcsFields)
 {
-    NS_LOG_FUNCTION(this << known << +flags << +mcs);
-    m_mcsKnown = known;
-    m_mcsFlags = flags;
-    m_mcsRate = mcs;
-    if (!(m_present & RADIOTAP_MCS))
-    {
-        m_present |= RADIOTAP_MCS;
-        m_length += 3;
-    }
+    NS_LOG_FUNCTION(this << +mcsFields.known << +mcsFields.flags << +mcsFields.mcs);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_MCS), "MCS radiotap field already present");
+    m_present |= RADIOTAP_MCS;
+    m_length += sizeof(McsFields);
+    m_mcsFields = mcsFields;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
 }
 
 void
-RadiotapHeader::SetAmpduStatus(uint32_t referenceNumber, uint16_t flags, uint8_t crc)
+RadiotapHeader::SerializeMcs(Buffer::Iterator& start) const
 {
-    NS_LOG_FUNCTION(this << referenceNumber << flags);
-    m_ampduStatusRef = referenceNumber;
-    m_ampduStatusFlags = flags;
-    m_ampduStatusCRC = crc;
-    if (!(m_present & RADIOTAP_AMPDU_STATUS))
-    {
-        m_ampduStatusPad = ((4 - m_length % 4) % 4);
-        m_present |= RADIOTAP_AMPDU_STATUS;
-        m_length += (8 + m_ampduStatusPad);
-    }
+    start.WriteU8(m_mcsFields.known);
+    start.WriteU8(m_mcsFields.flags);
+    start.WriteU8(m_mcsFields.mcs);
+}
+
+uint32_t
+RadiotapHeader::DeserializeMcs(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_mcsFields.known = start.ReadU8();
+    m_mcsFields.flags = start.ReadU8();
+    m_mcsFields.mcs = start.ReadU8();
+    return sizeof(McsFields);
+}
+
+void
+RadiotapHeader::PrintMcs(std::ostream& os) const
+{
+    os << " mcs.known=0x" << std::hex << +m_mcsFields.known << " mcs.flags0x=" << +m_mcsFields.flags
+       << " mcsRate=" << std::dec << +m_mcsFields.mcs;
+}
+
+void
+RadiotapHeader::SetAmpduStatus(const AmpduStatusFields& ampduStatusFields)
+{
+    NS_LOG_FUNCTION(this << ampduStatusFields.referenceNumber << ampduStatusFields.flags);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_AMPDU_STATUS),
+                  "A-MPDU status radiotap field already present");
+    m_ampduStatusPad = ((4 - m_length % 4) % 4);
+    m_present |= RADIOTAP_AMPDU_STATUS;
+    m_length += (sizeof(ampduStatusFields) + m_ampduStatusPad);
+    m_ampduStatusFields = ampduStatusFields;
+
+    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
+                      << std::dec);
+}
+
+void
+RadiotapHeader::SerializeAmpduStatus(Buffer::Iterator& start) const
+{
+    start.WriteU8(0, m_ampduStatusPad);
+    start.WriteU32(m_ampduStatusFields.referenceNumber);
+    start.WriteU16(m_ampduStatusFields.flags);
+    start.WriteU8(m_ampduStatusFields.crc);
+    start.WriteU8(m_ampduStatusFields.reserved);
+}
+
+uint32_t
+RadiotapHeader::DeserializeAmpduStatus(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_ampduStatusPad = ((4 - bytesRead % 4) % 4);
+    start.Next(m_ampduStatusPad);
+    m_ampduStatusFields.referenceNumber = start.ReadU32();
+    m_ampduStatusFields.flags = start.ReadU16();
+    m_ampduStatusFields.crc = start.ReadU8();
+    m_ampduStatusFields.reserved = start.ReadU8();
+    return sizeof(AmpduStatusFields) + m_ampduStatusPad;
+}
+
+void
+RadiotapHeader::PrintAmpduStatus(std::ostream& os) const
+{
+    os << " ampduStatus.flags=0x" << std::hex << m_ampduStatusFields.flags << std::dec;
+}
+
+void
+RadiotapHeader::SetVhtFields(const VhtFields& vhtFields)
+{
+    NS_LOG_FUNCTION(this << vhtFields.known << vhtFields.flags << +vhtFields.mcsNss.at(0)
+                         << +vhtFields.mcsNss.at(1) << +vhtFields.mcsNss.at(2)
+                         << +vhtFields.mcsNss.at(3) << +vhtFields.coding << +vhtFields.groupId
+                         << +vhtFields.partialAid);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_VHT), "VHT radiotap field already present");
+    m_vhtPad = ((2 - m_length % 2) % 2);
+    m_present |= RADIOTAP_VHT;
+    m_length += (sizeof(VhtFields) + m_vhtPad);
+    m_vhtFields = vhtFields;
+
+    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
+                      << std::dec);
+}
+
+void
+RadiotapHeader::SerializeVht(Buffer::Iterator& start) const
+{
+    start.WriteU8(0, m_vhtPad);
+    start.WriteU16(m_vhtFields.known);
+    start.WriteU8(m_vhtFields.flags);
+    start.WriteU8(m_vhtFields.bandwidth);
+    for (const auto mcsNss : m_vhtFields.mcsNss)
+    {
+        start.WriteU8(mcsNss);
+    }
+    start.WriteU8(m_vhtFields.coding);
+    start.WriteU8(m_vhtFields.groupId);
+    start.WriteU16(m_vhtFields.partialAid);
+}
+
+uint32_t
+RadiotapHeader::DeserializeVht(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_vhtPad = ((2 - bytesRead % 2) % 2);
+    start.Next(m_vhtPad);
+    m_vhtFields.known = start.ReadU16();
+    m_vhtFields.flags = start.ReadU8();
+    m_vhtFields.bandwidth = start.ReadU8();
+    for (auto& mcsNss : m_vhtFields.mcsNss)
+    {
+        mcsNss = start.ReadU8();
+    }
+    m_vhtFields.coding = start.ReadU8();
+    m_vhtFields.groupId = start.ReadU8();
+    m_vhtFields.partialAid = start.ReadU16();
+    return sizeof(VhtFields) + m_vhtPad;
+}
+
+void
+RadiotapHeader::PrintVht(std::ostream& os) const
+{
+    os << " vht.known=0x" << m_vhtFields.known << " vht.flags=0x" << m_vhtFields.flags
+       << " vht.bandwidth=" << std::dec << m_vhtFields.bandwidth
+       << " vht.mcsNss[0]=" << +m_vhtFields.mcsNss.at(0)
+       << " vht.mcsNss[1]=" << +m_vhtFields.mcsNss.at(1)
+       << " vht.mcsNss[2]=" << +m_vhtFields.mcsNss.at(2)
+       << " vht.mcsNss[3]=" << +m_vhtFields.mcsNss.at(3) << " vht.coding=" << m_vhtFields.coding
+       << " vht.groupId=" << m_vhtFields.groupId << " vht.partialAid=" << m_vhtFields.partialAid;
+}
+
+void
+RadiotapHeader::SetHeFields(const HeFields& heFields)
+{
+    NS_LOG_FUNCTION(this << heFields.data1 << heFields.data2 << heFields.data3 << heFields.data4
+                         << heFields.data5 << heFields.data6);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_HE), "HE radiotap field already present");
+    m_hePad = ((2 - m_length % 2) % 2);
+    m_present |= RADIOTAP_HE;
+    m_length += (sizeof(heFields) + m_hePad);
+    m_heFields = heFields;
+
+    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
+                      << std::dec);
+}
+
+void
+RadiotapHeader::SerializeHe(Buffer::Iterator& start) const
+{
+    start.WriteU8(0, m_hePad);
+    start.WriteU16(m_heFields.data1);
+    start.WriteU16(m_heFields.data2);
+    start.WriteU16(m_heFields.data3);
+    start.WriteU16(m_heFields.data4);
+    start.WriteU16(m_heFields.data5);
+    start.WriteU16(m_heFields.data6);
+}
+
+uint32_t
+RadiotapHeader::DeserializeHe(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_hePad = ((2 - bytesRead % 2) % 2);
+    start.Next(m_hePad);
+    m_heFields.data1 = start.ReadU16();
+    m_heFields.data2 = start.ReadU16();
+    m_heFields.data3 = start.ReadU16();
+    m_heFields.data4 = start.ReadU16();
+    m_heFields.data5 = start.ReadU16();
+    m_heFields.data6 = start.ReadU16();
+    return sizeof(HeFields) + m_hePad;
+}
+
+void
+RadiotapHeader::PrintHe(std::ostream& os) const
+{
+    os << " he.data1=0x" << std::hex << m_heFields.data1 << " he.data2=0x" << std::hex
+       << m_heFields.data2 << " he.data3=0x" << std::hex << m_heFields.data3 << " he.data4=0x"
+       << std::hex << m_heFields.data4 << " he.data5=0x" << std::hex << m_heFields.data5
+       << " he.data6=0x" << std::hex << m_heFields.data6 << std::dec;
+}
+
+void
+RadiotapHeader::SetHeMuFields(const HeMuFields& heMuFields)
+{
+    NS_LOG_FUNCTION(this << heMuFields.flags1 << heMuFields.flags2);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_HE_MU), "HE-MU radiotap field already present");
+    m_heMuPad = ((2 - m_length % 2) % 2);
+    m_present |= RADIOTAP_HE_MU;
+    m_length += (sizeof(heMuFields) + m_heMuPad);
+    m_heMuFields = heMuFields;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
 }
 
 void
-RadiotapHeader::SetVhtFields(uint16_t known,
-                             uint8_t flags,
-                             uint8_t bandwidth,
-                             uint8_t mcs_nss[4],
-                             uint8_t coding,
-                             uint8_t group_id,
-                             uint16_t partial_aid)
+RadiotapHeader::SerializeHeMu(Buffer::Iterator& start) const
+{
+    start.WriteU8(0, m_heMuPad);
+    start.WriteU16(m_heMuFields.flags1);
+    start.WriteU16(m_heMuFields.flags2);
+    for (const auto ruChannel : m_heMuFields.ruChannel1)
+    {
+        start.WriteU8(ruChannel);
+    }
+    for (const auto ruChannel : m_heMuFields.ruChannel2)
+    {
+        start.WriteU8(ruChannel);
+    }
+}
+
+uint32_t
+RadiotapHeader::DeserializeHeMu(Buffer::Iterator start, uint32_t bytesRead)
 {
-    NS_LOG_FUNCTION(this << known << flags << +mcs_nss[0] << +mcs_nss[1] << +mcs_nss[2]
-                         << +mcs_nss[3] << +coding << +group_id << +partial_aid);
-    m_vhtKnown = known;
-    m_vhtFlags = flags;
-    m_vhtBandwidth = bandwidth;
-    for (uint8_t i = 0; i < 4; i++)
+    m_heMuPad = ((2 - bytesRead % 2) % 2);
+    start.Next(m_heMuPad);
+    m_heMuFields.flags1 = start.ReadU16();
+    m_heMuFields.flags2 = start.ReadU16();
+    for (auto& ruChannel : m_heMuFields.ruChannel1)
     {
-        m_vhtMcsNss[i] = mcs_nss[i];
+        ruChannel = start.ReadU8();
     }
-    m_vhtCoding = coding;
-    m_vhtGroupId = group_id;
-    m_vhtPartialAid = partial_aid;
-    if (!(m_present & RADIOTAP_VHT))
+    for (auto& ruChannel : m_heMuFields.ruChannel2)
     {
-        m_vhtPad = ((2 - m_length % 2) % 2);
-        m_present |= RADIOTAP_VHT;
-        m_length += (12 + m_vhtPad);
+        ruChannel = start.ReadU8();
     }
+    return sizeof(HeMuFields) + m_heMuPad;
+}
+
+void
+RadiotapHeader::PrintHeMu(std::ostream& os) const
+{
+    os << " heMu.flags1=0x" << std::hex << m_heMuFields.flags1 << " heMu.flags2=0x"
+       << m_heMuFields.flags2 << std::dec;
+}
+
+void
+RadiotapHeader::SetHeMuOtherUserFields(const HeMuOtherUserFields& heMuOtherUserFields)
+{
+    NS_LOG_FUNCTION(this << heMuOtherUserFields.perUser1 << heMuOtherUserFields.perUser2
+                         << +heMuOtherUserFields.perUserPosition
+                         << +heMuOtherUserFields.perUserKnown);
+
+    NS_ASSERT_MSG(!(m_present & RADIOTAP_HE_MU_OTHER_USER),
+                  "HE-MU-other-user radiotap field already present");
+    m_heMuOtherUserPad = ((2 - m_length % 2) % 2);
+    m_present |= RADIOTAP_HE_MU_OTHER_USER;
+    m_length += (sizeof(HeMuOtherUserFields) + m_heMuOtherUserPad);
+    m_heMuOtherUserFields = heMuOtherUserFields;
 
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
                       << std::dec);
 }
 
 void
-RadiotapHeader::SetHeFields(uint16_t data1,
-                            uint16_t data2,
-                            uint16_t data3,
-                            uint16_t data4,
-                            uint16_t data5,
-                            uint16_t data6)
+RadiotapHeader::SerializeHeMuOtherUser(Buffer::Iterator& start) const
 {
-    NS_LOG_FUNCTION(this << data1 << data2 << data3 << data4 << data5 << data6);
-    m_heData1 = data1;
-    m_heData2 = data2;
-    m_heData3 = data3;
-    m_heData4 = data4;
-    m_heData5 = data5;
-    m_heData6 = data6;
-    if (!(m_present & RADIOTAP_HE))
+    start.WriteU8(0, m_heMuOtherUserPad);
+    start.WriteU16(m_heMuOtherUserFields.perUser1);
+    start.WriteU16(m_heMuOtherUserFields.perUser2);
+    start.WriteU8(m_heMuOtherUserFields.perUserPosition);
+    start.WriteU8(m_heMuOtherUserFields.perUserKnown);
+}
+
+uint32_t
+RadiotapHeader::DeserializeHeMuOtherUser(Buffer::Iterator start, uint32_t bytesRead)
+{
+    m_heMuOtherUserPad = ((2 - bytesRead % 2) % 2);
+    start.Next(m_heMuOtherUserPad);
+    m_heMuOtherUserFields.perUser1 = start.ReadU16();
+    m_heMuOtherUserFields.perUser2 = start.ReadU16();
+    m_heMuOtherUserFields.perUserPosition = start.ReadU8();
+    m_heMuOtherUserFields.perUserKnown = start.ReadU8();
+    return sizeof(HeMuOtherUserFields) + m_heMuOtherUserPad;
+}
+
+void
+RadiotapHeader::PrintHeMuOtherUser(std::ostream& os) const
+{
+    os << " heMuOtherUser.perUser1=" << m_heMuOtherUserFields.perUser1
+       << " heMuOtherUser.perUser2=" << m_heMuOtherUserFields.perUser2
+       << " heMuOtherUser.perUserPosition=" << m_heMuOtherUserFields.perUserPosition
+       << " heMuOtherUser.perUserKnown=0x" << std::hex << m_heMuOtherUserFields.perUserKnown
+       << std::dec;
+}
+
+void
+RadiotapHeader::SetUsigFields(const UsigFields& usigFields)
+{
+    NS_LOG_FUNCTION(this << usigFields.common << usigFields.mask << usigFields.value);
+    if (!m_presentExt)
     {
-        m_hePad = ((2 - m_length % 2) % 2);
-        m_present |= RADIOTAP_HE;
-        m_length += (12 + m_hePad);
+        m_present |= RADIOTAP_TLV | RADIOTAP_EXT;
+        m_presentExt = 0;
+        m_length += sizeof(RadiotapExtFlags);
     }
 
+    NS_ASSERT_MSG(!(*m_presentExt & RADIOTAP_USIG), "U-SIG radiotap field already present");
+    *m_presentExt |= RADIOTAP_USIG;
+
+    m_usigTlvPad = ((8 - m_length % 8) % 8);
+    m_usigTlv.type = 32 + std::countr_zero<uint16_t>(RADIOTAP_USIG);
+    m_usigTlv.length = sizeof(UsigFields);
+    m_length += sizeof(TlvFields) + m_usigTlvPad;
+
+    m_usigPad = ((4 - m_length % 4) % 4);
+    m_usigFields = usigFields;
+    m_length += m_usigTlv.length + m_usigPad;
+
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
-                      << std::dec);
+                      << " m_presentExt=0x" << *m_presentExt << std::dec);
 }
 
 void
-RadiotapHeader::SetHeMuFields(uint16_t flags1,
-                              uint16_t flags2,
-                              const std::array<uint8_t, 4>& /*ruChannel1*/,
-                              const std::array<uint8_t, 4>& /*ruChannel2*/)
+RadiotapHeader::SerializeUsig(Buffer::Iterator& start) const
 {
-    NS_LOG_FUNCTION(this << flags1 << flags2);
-    m_heMuFlags1 = flags1;
-    m_heMuFlags2 = flags2;
-    if (!(m_present & RADIOTAP_HE_MU))
+    start.WriteU8(0, m_usigTlvPad);
+    start.WriteU16(m_usigTlv.type);
+    start.WriteU16(m_usigTlv.length);
+    start.WriteU8(0, m_usigPad);
+    start.WriteU32(m_usigFields.common);
+    start.WriteU32(m_usigFields.value);
+    start.WriteU32(m_usigFields.mask);
+}
+
+uint32_t
+RadiotapHeader::DeserializeUsig(Buffer::Iterator start, uint32_t bytesRead)
+{
+    const auto startBytesRead = bytesRead;
+    m_usigTlvPad = ((8 - bytesRead % 8) % 8);
+    start.Next(m_usigTlvPad);
+    bytesRead += m_usigTlvPad;
+    m_usigTlv.type = start.ReadU16();
+    m_usigTlv.length = start.ReadU16();
+    bytesRead += sizeof(TlvFields);
+    m_usigPad = ((4 - bytesRead % 4) % 4);
+    start.Next(m_usigPad);
+    bytesRead += m_usigPad;
+    m_usigFields.common = start.ReadU32();
+    m_usigFields.value = start.ReadU32();
+    m_usigFields.mask = start.ReadU32();
+    bytesRead += sizeof(UsigFields);
+    return bytesRead - startBytesRead;
+}
+
+void
+RadiotapHeader::PrintUsig(std::ostream& os) const
+{
+    os << " usig.common=0x" << std::hex << m_usigFields.common << " usig.value=0x"
+       << m_usigFields.value << " usig.mask=0x" << m_usigFields.mask << std::dec;
+}
+
+void
+RadiotapHeader::SetEhtFields(const EhtFields& ehtFields)
+{
+    NS_LOG_FUNCTION(this << ehtFields.known);
+    if (!m_presentExt)
     {
-        m_heMuPad = ((2 - m_length % 2) % 2);
-        m_present |= RADIOTAP_HE_MU;
-        m_length += (12 + m_heMuPad);
+        m_present |= RADIOTAP_TLV | RADIOTAP_EXT;
+        m_presentExt = 0;
+        m_length += sizeof(RadiotapExtFlags);
     }
 
+    NS_ASSERT_MSG(!(*m_presentExt & RADIOTAP_EHT_SIG), "EHT radiotap field already present");
+    *m_presentExt |= RADIOTAP_EHT_SIG;
+
+    m_ehtTlvPad = ((8 - m_length % 8) % 8);
+    m_ehtTlv.type = 32 + std::countr_zero<uint16_t>(RADIOTAP_EHT_SIG);
+    m_ehtTlv.length = (40 + ehtFields.userInfo.size() * 4);
+    m_length += sizeof(TlvFields) + m_ehtTlvPad;
+
+    m_ehtPad = ((4 - m_length % 4) % 4);
+    m_ehtFields = ehtFields;
+    m_length += m_ehtTlv.length + m_ehtPad;
+
     NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
-                      << std::dec);
+                      << " m_presentExt=0x" << *m_presentExt << std::dec);
 }
 
 void
-RadiotapHeader::SetHeMuPerUserFields(uint16_t perUser1,
-                                     uint16_t perUser2,
-                                     uint8_t perUserPosition,
-                                     uint8_t perUserKnown)
+RadiotapHeader::SerializeEht(Buffer::Iterator& start) const
 {
-    NS_LOG_FUNCTION(this << perUser1 << perUser2 << +perUserPosition << +perUserKnown);
-    m_heMuPerUser1 = perUser1;
-    m_heMuPerUser2 = perUser2;
-    m_heMuPerUserPosition = perUserPosition;
-    m_heMuPerUserKnown = perUserKnown;
-    if (!(m_present & RADIOTAP_HE_MU_OTHER_USER))
+    start.WriteU8(0, m_ehtTlvPad);
+    start.WriteU16(m_ehtTlv.type);
+    start.WriteU16(m_ehtTlv.length);
+    start.WriteU8(0, m_ehtPad);
+    start.WriteU32(m_ehtFields.known);
+    for (const auto dataField : m_ehtFields.data)
+    {
+        start.WriteU32(dataField);
+    }
+    for (const auto userInfoField : m_ehtFields.userInfo)
     {
-        m_heMuOtherUserPad = ((2 - m_length % 2) % 2);
-        m_present |= RADIOTAP_HE_MU_OTHER_USER;
-        m_length += (6 + m_heMuOtherUserPad);
+        start.WriteU32(userInfoField);
     }
+}
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present
-                      << std::dec);
+uint32_t
+RadiotapHeader::DeserializeEht(Buffer::Iterator start, uint32_t bytesRead)
+{
+    const auto startBytesRead = bytesRead;
+
+    m_ehtTlvPad = ((8 - bytesRead % 8) % 8);
+    start.Next(m_ehtTlvPad);
+    bytesRead += m_ehtTlvPad;
+    m_ehtTlv.type = start.ReadU16();
+    m_ehtTlv.length = start.ReadU16();
+    bytesRead += sizeof(TlvFields);
+
+    m_ehtPad = ((4 - bytesRead % 4) % 4);
+    start.Next(m_ehtPad);
+    bytesRead += m_ehtPad;
+    m_ehtFields.known = start.ReadU32();
+    bytesRead += 4;
+    for (auto& dataField : m_ehtFields.data)
+    {
+        dataField = start.ReadU32();
+        bytesRead += 4;
+    }
+    const auto userInfosBytes = m_ehtTlv.length - bytesRead - m_ehtTlvPad;
+    NS_ASSERT(userInfosBytes % 4 == 0);
+    const std::size_t numUsers = userInfosBytes / 4;
+    for (std::size_t i = 0; i < numUsers; ++i)
+    {
+        m_ehtFields.userInfo.push_back(start.ReadU32());
+        bytesRead += 4;
+    }
+
+    return bytesRead - startBytesRead;
+}
+
+void
+RadiotapHeader::PrintEht(std::ostream& os) const
+{
+    os << " eht.known=0x" << std::hex << m_ehtFields.known;
+    std::size_t index = 0;
+    for (const auto dataField : m_ehtFields.data)
+    {
+        os << " eht.data" << index++ << "=0x" << dataField;
+    }
+    index = 0;
+    for (const auto userInfoField : m_ehtFields.userInfo)
+    {
+        os << " eht.userInfo" << index++ << "=0x" << userInfoField;
+    }
+    os << std::dec;
 }
 
 } // namespace ns3
